using MediatR.Behaviors.Authorization;
using ExpenseTracker.Application.Common.Authorization;
using ExpenseTracker.Application.Common.Interfaces.Services;

namespace ExpenseTracker.Application.Accounts.Commands.Import.Json.Many;

public class ImportJsonAccountsQueryAuthorizer : AbstractRequestAuthorizer<ImportJsonAccountsQuery>
{
    private readonly ISessionUserService _sessionUserService;

    public ImportJsonAccountsQueryAuthorizer(ISessionUserService currentUserService)
    {
        _sessionUserService = currentUserService;
    }

    public override void BuildPolicy(ImportJsonAccountsQuery request)
    {
        UseRequirement(new MustBeAuthenticatedRequirement
        {
            IsAuthenticated = _sessionUserService.IsAuthenticated
        });
    }
}
