using MediatR.Behaviors.Authorization;
using ExpenseTracker.Application.Common.Authorization;
using ExpenseTracker.Application.Common.Interfaces.Services;

namespace ExpenseTracker.Application.Accounts.Commands.Import.Json.One;

public class ImportJsonAccountQueryAuthorizer : AbstractRequestAuthorizer<ImportJsonAccountQuery>
{
    private readonly ISessionUserService _sessionUserService;

    public ImportJsonAccountQueryAuthorizer(ISessionUserService currentUserService)
    {
        _sessionUserService = currentUserService;
    }

    public override void BuildPolicy(ImportJsonAccountQuery request)
    {
        UseRequirement(new MustBeAuthenticatedRequirement
        {
            IsAuthenticated = _sessionUserService.IsAuthenticated
        });
    }
}
