using MediatR.Behaviors.Authorization;
using ExpenseTracker.Application.Common.Authorization;
using ExpenseTracker.Application.Common.Interfaces.Services;

namespace ExpenseTracker.Application.Accounts.Queries.Export.Json.Many;

public class ExportJsonAccountsQueryAuthorizer : AbstractRequestAuthorizer<ExportJsonAccountsQuery>
{
    private readonly ISessionUserService _sessionUserService;

    public ExportJsonAccountsQueryAuthorizer(ISessionUserService currentUserService)
    {
        _sessionUserService = currentUserService;
    }

    public override void BuildPolicy(ExportJsonAccountsQuery request)
    {
        UseRequirement(new MustBeAuthenticatedRequirement
        {
            IsAuthenticated = _sessionUserService.IsAuthenticated
        });
    }
}

