using ExpenseTracker.Application.Common.Models;
using MediatR;

namespace ExpenseTracker.Application.Accounts.Queries.GetWithPagination;

public record GetAccountsWithPaginationQuery : IRequest<PaginatedList<AccountDto>>
{
    public int PageNumber { get; set; } = 1;

    public int PageSize { get; set; } = 10;

    public bool GetAll { get; set; } = false;
}
