using ExpenseTracker.Application.Common.Interfaces.Services;
using MediatR;

namespace ExpenseTracker.Application.Authentication.Commands.RegisterWithEmail;

public class RegisterWithEmailCommandHandler : IRequestHandler<RegisterWithEmailCommand>
{
    private readonly IAuthenticationService _authenticationService;

    public RegisterWithEmailCommandHandler(IAuthenticationService authenticationService)
    {
        _authenticationService = authenticationService;
    }

    public async Task Handle(RegisterWithEmailCommand request, CancellationToken cancellationToken)
    {
        await _authenticationService.RegisterWithEmailAsync(request.Email, cancellationToken);
    }
}
