using ExpenseTracker.Application.Common.Interfaces.Services;
using MediatR;

namespace ExpenseTracker.Application.Authentication.Commands.RegisterWithEmailAndPassword;

public class RegisterWithEmailAndPasswordCommandHandler : IRequestHandler<RegisterWithEmailAndPasswordCommand>
{
    private readonly IAuthenticationService _authenticationService;

    public RegisterWithEmailAndPasswordCommandHandler(IAuthenticationService authenticationService)
    {
        _authenticationService = authenticationService;
    }

    public async Task Handle(RegisterWithEmailAndPasswordCommand request, CancellationToken cancellationToken)
    {
        await _authenticationService.RegisterWithEmailAndPasswordAsync(request.Email, request.Password, cancellationToken);
    }
}
