using ExpenseTracker.Application.Common.Interfaces.Services;
using MediatR;

namespace ExpenseTracker.Application.Authentication.Commands.RenewAccessTokenWithBody;

public class RenewAccessTokenWithBodyCommandHandler : IRequestHandler<RenewAccessTokenWithBodyCommand, TokensModel>
{
    private readonly IAuthenticationService _authenticationService;

    public RenewAccessTokenWithBodyCommandHandler(IAuthenticationService authenticationService)
    {
        _authenticationService = authenticationService;
    }

    public async Task<TokensModel> Handle(RenewAccessTokenWithBodyCommand request, CancellationToken cancellationToken)
    {
        return await _authenticationService.RenewAccessTokenAsync(request.RefreshToken, cancellationToken);
    }
}
