using ExpenseTracker.Application.Common.Interfaces.Services;
using MediatR;

namespace ExpenseTracker.Application.Authentication.Commands.RevokeRefreshTokenWithBody;

public class RevokeRefreshTokenWithBodyCommandHandler : IRequestHandler<RevokeRefreshTokenWithBodyCommand>
{
    private readonly IAuthenticationService _authenticationService;

    public RevokeRefreshTokenWithBodyCommandHandler(IAuthenticationService authenticationService)
    {
        _authenticationService = authenticationService;
    }

    public async Task Handle(RevokeRefreshTokenWithBodyCommand request, CancellationToken cancellationToken)
    {
        await _authenticationService.RevokeRefreshTokenAsync(request.RefreshToken, cancellationToken);
    }
}
