using ExpenseTracker.Application.Common.Interfaces.Services;
using MediatR;

namespace ExpenseTracker.Application.Authentication.Commands.RevokeRefreshTokenWithCookie;

public class RevokeRefreshTokenWithCookieCommandHandler : IRequestHandler<RevokeRefreshTokenWithCookieCommand>
{
    private readonly ISessionUserService _sessionUserService;
    private readonly IAuthenticationService _authenticationService;

    public RevokeRefreshTokenWithCookieCommandHandler(
        ISessionUserService sessionUserService,
        IAuthenticationService authenticationService)
    {
        _sessionUserService = sessionUserService;
        _authenticationService = authenticationService;
    }

    public async Task Handle(RevokeRefreshTokenWithCookieCommand request, CancellationToken cancellationToken)
    {
        await _authenticationService.RevokeRefreshTokenAsync(_sessionUserService.RefreshToken, cancellationToken);
    }
}
