using ExpenseTracker.Application.Common.Interfaces.Services;
using FluentValidation;

namespace ExpenseTracker.Application.Authentication.Commands.RevokeRefreshTokenWithCookie;

public class RevokeRefreshTokenWithBodyCommandValidator : AbstractValidator<RevokeRefreshTokenWithCookieCommand>
{
    private readonly ISessionUserService _sessionUserService;

    public RevokeRefreshTokenWithBodyCommandValidator(ISessionUserService sessionUserService)
    {
        _sessionUserService = sessionUserService;

        RuleFor(e => e)
            .Must(_ => _sessionUserService.RefreshToken != null);
    }
}
