using ExpenseTracker.Application.Common.Interfaces.Repositories;

namespace ExpenseTracker.Application.Common.Interfaces;

public interface IUnitOfWork : IDisposable
{
    IAccountRepository AccountRepository { get; }
    ITransactionRepository TransactionRepository { get; }

    int Save();
    Task<int> SaveAsync(CancellationToken cancellationToken);
}
