using ExpenseTracker.Application.Authentication;

namespace ExpenseTracker.Application.Common.Interfaces.Services;

public interface IAuthenticationService
{
    Task RegisterWithEmailAndPasswordAsync(string email, string password, CancellationToken cancellationToken);

    Task RegisterWithEmailAsync(string email, CancellationToken cancellationToken);

    Task<TokensModel> LoginAsync(string email, string password, CancellationToken cancellationToken);

    Task<TokensModel> RenewAccessTokenAsync(string refreshToken, CancellationToken cancellationToken);

    Task RevokeRefreshTokenAsync(string refreshToken, CancellationToken cancellationToken);
}
