using ExpenseTracker.Application.Common.Models;
using MediatR;

namespace ExpenseTracker.Application.Transactions.Queries.GetWithPagination;

public record GetTransactionsWithPaginationQuery : IRequest<PaginatedList<TransactionDto>>
{
    public int PageNumber { get; set; } = 1;

    public int PageSize { get; set; } = 10;

    public string AccountId { get; set; }
}
