using FluentValidation;

namespace ExpenseTracker.Application.Transactions.Queries.GetWithPagination;

public class GetTransactionsWithPaginationQueryValidator : AbstractValidator<GetTransactionsWithPaginationQuery>
{
    public GetTransactionsWithPaginationQueryValidator()
    {
        RuleFor(v => v.PageNumber)
            .GreaterThanOrEqualTo(1);

        RuleFor(v => v.PageSize)
            .GreaterThanOrEqualTo(1)
            .LessThanOrEqualTo(50);
    }
}
